/* alu_header.v - Constants that will be useful to source code using the alu

   This file is part of the 9086 project.

   Copyright (c) 2023 Efthymios Kritikos

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

`define ALU_OP_BITS 3
`define ALU_OP_ADD		3'b000
`define ALU_OP_SUB		3'b001
`define ALU_OP_AND		3'b010
`define ALU_OP_OR		3'b011
`define ALU_OP_XOR		3'b100
`define ALU_OP_ADD_SIGNED_B	3'b101
`define ALU_OP_SUB_REVERSE	3'b110
`define ALU_OP_SHIFT_LEFT	3'b111
